package cn.com.taiji.service.impl;

import cn.com.taiji.constants.TopicConstants;
import cn.com.taiji.entity.*;
import cn.com.taiji.service.SimulationTrackService;
import cn.com.taiji.utils.LocationUtils;
import cn.hutool.core.date.DateUtil;
import cn.hutool.json.JSONUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.poi.ss.formula.functions.T;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.RequestParam;

import javax.annotation.Resource;
import java.util.HashSet;
import java.util.List;

/**
 * @author chenfangchao
 * @title: SimulationTrackImpl
 * @projectName es-track-analysis
 * @description: TODO
 * @date 2023/2/7 5:16 PM
 */
@Slf4j
@Service
public class SimulationTrackImpl implements SimulationTrackService {


    @Resource
    private KafkaTemplate<String, Object> kafkaTemplate;


    public static void main(String[] args) {
    }


    HashSet<Thread> beidouThreads = new HashSet<>();

    private Integer beidouStatus;


    HashSet<Thread> beidouNewThreads = new HashSet<>();

    private Integer beidouNewStatus;

    private Integer beidouType;

    HashSet<Thread> hlxOneLevelTherads = new HashSet<>();

    private Integer hlxOneLevelStatus;


    HashSet<Thread> beidouhlxOneLevelTherads = new HashSet<>();

    private Integer beidouhlxOneLevelStatus;


    HashSet<Thread> tianaoTherads = new HashSet<>();

    private Integer tianaoStatus;

    private Integer tianaoType;


    @Override
    public void beidouTrack(Integer status) {
        //开始位置 109.67642971192785,18.18460507789732 三亚位置 西州
        //结束位置 109.69596855881268,18.185299250953545 三亚位置 东洲
        //模拟同船的第一个设备
        beidouStatus = status;
        if (0 == beidouStatus) {
            Thread thread = new Thread(() -> {
                while (true) {
                    boolean interrupted = Thread.currentThread().isInterrupted();
                    if (interrupted) {
                        break;
                    }
                    List<Location> list = LocationUtils.generateLogLat("2023-02-03 00:00:00", "2023-02-03 00:02:10", 109.67642971192785, 18.18460507789732, 109.69596855881268, 18.185299250953545);
                    for (Location location : list) {
                        BeidouShipTrackDTO beidouShipTrackDTO = new BeidouShipTrackDTO();
                        beidouShipTrackDTO.setId("20236688");
                        beidouShipTrackDTO.setCurren_time(DateUtil.now());
                        beidouShipTrackDTO.setTrackId(20236688);
                        beidouShipTrackDTO.setDeviceId(20236688);
                        beidouShipTrackDTO.setSendTime(DateUtil.now());
                        beidouShipTrackDTO.setLocationTime(DateUtil.now());
                        beidouShipTrackDTO.setShipName("20236688测试船舶");
                        beidouShipTrackDTO.setReceiveTime(DateUtil.now());
                        beidouShipTrackDTO.setLongitude(location.getLog());
                        beidouShipTrackDTO.setLatitude(location.getLat());
                        String data = JSONUtil.toJsonStr(beidouShipTrackDTO);
                        try {
                            Thread.sleep(1000);
                            kafkaTemplate.send(TopicConstants.BEIDOU_TOPIC, data);
                            log.info(DateUtil.now() + "模拟北斗船舶:20236688测试船舶,终端号为20236688完成");
                        } catch (InterruptedException e) {
                            Thread.currentThread().interrupt();
                            e.printStackTrace();
                        }
                    }
                }
            });
            Thread thread1 = new Thread(() -> {
                while (true) {
                    boolean interrupted = Thread.currentThread().isInterrupted();
                    if (interrupted) {
                        break;
                    }
                    /**
                     * 开始位置 109.67638187069215,18.184651060263896 三亚位置 西州偏北一点
                     * 结束位置 109.69603272744908,18.18548237188056 三亚位置 东洲偏北一点
                     */
                    //模拟同船的第二个设备
                    List<Location> list1 = LocationUtils.generateLogLat("2023-02-03 00:00:00", "2023-02-03 00:02:10", 109.67638187069215, 18.184651060263896, 109.69603272744908, 18.18548237188056);
                    for (Location location : list1) {
                        BeidouShipTrackDTO beidouShipTrackDTO = new BeidouShipTrackDTO();
                        beidouShipTrackDTO.setId("20236699");
                        beidouShipTrackDTO.setCurren_time(DateUtil.now());
                        beidouShipTrackDTO.setTrackId(20236699);
                        beidouShipTrackDTO.setDeviceId(20236699);
                        beidouShipTrackDTO.setSendTime(DateUtil.now());
                        beidouShipTrackDTO.setLocationTime(DateUtil.now());
                        beidouShipTrackDTO.setShipName("20236688测试船舶");
                        beidouShipTrackDTO.setReceiveTime(DateUtil.now());
                        beidouShipTrackDTO.setLongitude(location.getLog());
                        beidouShipTrackDTO.setLatitude(location.getLat());
                        String data = JSONUtil.toJsonStr(beidouShipTrackDTO);
                        try {
                            Thread.sleep(1000);
                            kafkaTemplate.send(TopicConstants.BEIDOU_TOPIC, data);
                            log.info(DateUtil.now() + "模拟北斗船舶:20236688测试船舶,终端号为20236699完成");
                        } catch (InterruptedException e) {
                            Thread.currentThread().interrupt();
                            e.printStackTrace();
                        }
                    }
                }
            });
            thread.start();
            thread1.start();
            beidouThreads.add(thread);
            beidouThreads.add(thread1);
        }
        if (1 == beidouStatus) {
            for (Thread item : beidouThreads) {
                item.interrupt();
            }
        }
    }

    @Override
    public void aisTrack(Integer status) {
        //开始位置 109.67642971192785,18.18460507789732
        //结束位置 109.69596855881268,18.185299250953545
        //模拟同船的第一个设备
        hlxOneLevelStatus = status;
        if (hlxOneLevelStatus == 0) {
            Thread thread = new Thread(() -> {
                while (true) {
                    boolean interrupted = Thread.currentThread().isInterrupted();
                    if (interrupted) {
                        break;
                    }
                    List<Location> list = LocationUtils.generateLogLat("2023-02-03 00:00:00", "2023-02-03 00:02:10", 109.67642971192785, 18.18460507789732, 109.69596855881268, 18.185299250953545);
                    for (Location location : list) {
                        HlxOneLevelTrackDTO hlxOneLevelTrack = new HlxOneLevelTrackDTO();
                        hlxOneLevelTrack.setLatitude(location.getLat());
                        hlxOneLevelTrack.setLongitude(location.getLog());
                        hlxOneLevelTrack.setRadarID("20236666");
                        hlxOneLevelTrack.setTargetID("20236666");
                        hlxOneLevelTrack.setTime(DateUtil.now());
                        hlxOneLevelTrack.setVesselName("测试船舶20236666");
                        String data = JSONUtil.toJsonStr(hlxOneLevelTrack);
                        try {
                            Thread.sleep(1000);
                            kafkaTemplate.send(TopicConstants.HLX_ONE_LEVEL, data);
                            log.info(DateUtil.now() + "模拟海兰信一级融合船舶:测试船舶20236666,终端号为20236666完成");
                        } catch (InterruptedException e) {
                            Thread.currentThread().interrupt();
                            e.printStackTrace();
                        }
                    }
                }
            });
            Thread thread1 = new Thread(() -> {
                while (true) {
                    boolean interrupted = Thread.currentThread().isInterrupted();
                    if (interrupted) {
                        break;
                    }
                    /**
                     * 开始位置 109.67638187069215,18.184651060263896
                     * 结束位置 109.69603272744908,18.18548237188056
                     */
                    //模拟同船的第二个设备
                    List<Location> list1 = LocationUtils.generateLogLat("2023-02-03 00:00:00", "2023-02-03 00:02:10", 109.67638187069215, 18.184651060263896, 109.69603272744908, 18.18548237188056);
                    for (Location location : list1) {
                        HlxOneLevelTrackDTO hlxOneLevelTrack = new HlxOneLevelTrackDTO();
                        hlxOneLevelTrack.setLatitude(location.getLat());
                        hlxOneLevelTrack.setLongitude(location.getLog());
                        hlxOneLevelTrack.setRadarID("20236677");
                        hlxOneLevelTrack.setTargetID("20236677");
                        hlxOneLevelTrack.setTime(DateUtil.now());
                        hlxOneLevelTrack.setVesselName("测试船舶20236666");
                        String data = JSONUtil.toJsonStr(hlxOneLevelTrack);
                        try {
                            Thread.sleep(1000);
                            kafkaTemplate.send(TopicConstants.HLX_ONE_LEVEL, data);
                            log.info(DateUtil.now() + "模拟海兰信一级融合船舶:测试船舶20236666,终端号为20236677完成");
                        } catch (InterruptedException e) {
                            Thread.currentThread().interrupt();
                            e.printStackTrace();
                        }
                    }
                }
            });
            thread.start();
            thread1.start();
            hlxOneLevelTherads.add(thread);
            hlxOneLevelTherads.add(thread1);
        }

        if (1 == hlxOneLevelStatus) {
            for (Thread item : hlxOneLevelTherads) {
                item.interrupt();
            }
        }
    }

    @Override
    public void beidouaisTrack(Integer status) {
        beidouhlxOneLevelStatus = status;
        if (0 == beidouhlxOneLevelStatus) {
            Thread thread = new Thread(() -> {
                while (true) {
                    boolean interrupted = Thread.currentThread().isInterrupted();
                    if (interrupted) {
                        break;
                    }
                    List<Location> list = LocationUtils.generateLogLat("2023-02-03 00:00:00", "2023-02-03 00:02:10", 109.67642971192785, 18.18460507789732, 109.69596855881268, 18.185299250953545);
                    for (Location location : list) {
                        BeidouShipTrackDTO beidouShipTrackDTO = new BeidouShipTrackDTO();
                        beidouShipTrackDTO.setId("20236688");
                        beidouShipTrackDTO.setCurren_time(DateUtil.now());
                        beidouShipTrackDTO.setTrackId(20236688);
                        beidouShipTrackDTO.setDeviceId(20236688);
                        beidouShipTrackDTO.setSendTime(DateUtil.now());
                        beidouShipTrackDTO.setLocationTime(DateUtil.now());
                        beidouShipTrackDTO.setShipName("20236688测试船舶");
                        beidouShipTrackDTO.setReceiveTime(DateUtil.now());
                        beidouShipTrackDTO.setLongitude(location.getLog());
                        beidouShipTrackDTO.setLatitude(location.getLat());
                        String data = JSONUtil.toJsonStr(beidouShipTrackDTO);
                        try {
                            Thread.sleep(2500);
                            kafkaTemplate.send(TopicConstants.BEIDOU_TOPIC, data);
                            log.info(DateUtil.now() + "模拟北斗船舶:20236688测试船舶,终端号为20236688完成");
                        } catch (InterruptedException e) {
                            Thread.currentThread().interrupt();
                            e.printStackTrace();
                        }
                    }
                }
            });
            Thread thread1 = new Thread(() -> {
                while (true) {
                    boolean interrupted = Thread.currentThread().isInterrupted();
                    if (interrupted) {
                        break;
                    }
                    List<Location> list1 = LocationUtils.generateLogLat("2023-02-03 00:00:00", "2023-02-03 00:02:10", 109.67642971192785, 18.18460507789732, 109.69596855881268, 18.185299250953545);
                    for (Location location : list1) {
                        HlxOneLevelTrackDTO hlxOneLevelTrack = new HlxOneLevelTrackDTO();
                        hlxOneLevelTrack.setLatitude(location.getLat());
                        hlxOneLevelTrack.setLongitude(location.getLog());
                        hlxOneLevelTrack.setRadarID("20236666");
                        hlxOneLevelTrack.setTargetID("20236666");
                        hlxOneLevelTrack.setTime(DateUtil.now());
                        hlxOneLevelTrack.setVesselName("20236688测试船舶");
                        String data = JSONUtil.toJsonStr(hlxOneLevelTrack);
                        try {
                            Thread.sleep(2500);
                            kafkaTemplate.send(TopicConstants.HLX_ONE_LEVEL, data);
                            log.info(DateUtil.now() + "模拟海兰信一级融合船舶:20236688测试船舶,终端号为20236666完成");
                        } catch (InterruptedException e) {
                            Thread.currentThread().interrupt();
                            e.printStackTrace();
                        }
                    }
                }
            });
            thread.start();
            thread1.start();
            beidouhlxOneLevelTherads.add(thread);
            beidouhlxOneLevelTherads.add(thread1);
        }
        if (1 == beidouhlxOneLevelStatus) {
            for (Thread item : beidouhlxOneLevelTherads) {
                item.interrupt();
            }
        }
    }

    @Override
    public void tianaoTrack(Integer status, Integer type) {
        tianaoStatus = status;
        tianaoType = type;
        if (0 == tianaoStatus) {
            Thread thread = new Thread(() -> {
                while (true) {
                    boolean interrupted = Thread.currentThread().isInterrupted();
                    if (interrupted) {
                        break;
                    }
                    //开始位置1 109.09300314810106,19.671012727042697
                    //结束位置1 109.09690281197237,19.669125831751618
                    List<Location> list1 = LocationUtils.generateLogLatTianao("2023-02-19 14:00:00", "2023-02-19 14:30:00", 109.09300314810106, 19.671012727042697, 109.09690281197237, 19.669125831751618);
                    for (Location location : list1) {
                        TianaoNewRadar tianaoRadar = new TianaoNewRadar();
                        tianaoRadar.setTrackId("202302191");
                        tianaoRadar.setAltitude(10.6D);
                        tianaoRadar.setCollectTime(DateUtil.now());
                        tianaoRadar.setCourse(180D);
                        tianaoRadar.setFusionBatchNum("202302191");
                        tianaoRadar.setFusionTime(DateUtil.now());
                        tianaoRadar.setRadarBatchNum("202302191");
                        tianaoRadar.setRadarCode(202302191);
                        tianaoRadar.setReceiveTime(DateUtil.now());
                        tianaoRadar.setReliability("100.0");
                        tianaoRadar.setSpeed(18.8D);
                        tianaoRadar.setTargetProper(0D);
                        tianaoRadar.setTargetSize(10.0D);
                        tianaoRadar.setTraceState("84");
                        tianaoRadar.setLatitude(location.getLat());
                        tianaoRadar.setLongitude(location.getLog());
                        String data = JSONUtil.toJsonStr(tianaoRadar);
                        if (0 == tianaoType) {
                            try {
                                Thread.sleep(2500);
                                kafkaTemplate.send(TopicConstants.TIANAO_TOPIC, data);
                                log.info(DateUtil.now() + "模拟天奥船舶:天奥模拟船舶1,FusionBatchNum为202302191完成");
                            } catch (InterruptedException e) {
                                e.printStackTrace();
                                Thread.currentThread().interrupt();
                            }
                        }
                        if (1 == tianaoType) {
                            kafkaTemplate.send(TopicConstants.TIANAO_TOPIC, data);
                            log.info(DateUtil.now() + "模拟天奥船舶:天奥模拟船舶1,FusionBatchNum为202302191完成");
                        }
                    }
                }
            });
            Thread thread1 = new Thread(() -> {
                while (true) {
                    boolean interrupted = Thread.currentThread().isInterrupted();
                    if (interrupted) {
                        break;
                    }
                    //开始位置2 109.0929925146248,19.67097869991864
                    //结束位置2 109.0968340253979,19.66891947202822
                    List<Location> list2 = LocationUtils.generateLogLatTianao("2023-02-19 14:00:00", "2023-02-19 14:30:00", 109.0929925146248, 19.67097869991864, 109.0968340253979, 19.66891947202822);
                    for (Location location : list2) {
                        TianaoNewRadar tianaoRadar = new TianaoNewRadar();
                        tianaoRadar.setTrackId("202302192");
                        tianaoRadar.setAltitude(10.6D);
                        tianaoRadar.setCollectTime(DateUtil.now());
                        tianaoRadar.setCourse(180D);
                        tianaoRadar.setFusionBatchNum("202302192");
                        tianaoRadar.setFusionTime(DateUtil.now());
                        tianaoRadar.setRadarBatchNum("202302192");
                        tianaoRadar.setRadarCode(202302192);
                        tianaoRadar.setReceiveTime(DateUtil.now());
                        tianaoRadar.setReliability("100.0");
                        tianaoRadar.setSpeed(18.8D);
                        tianaoRadar.setTargetProper(0D);
                        tianaoRadar.setTargetSize(10.0D);
                        tianaoRadar.setTraceState("84");
                        tianaoRadar.setLatitude(location.getLat());
                        tianaoRadar.setLongitude(location.getLog());
                        String data = JSONUtil.toJsonStr(tianaoRadar);
                        if (0 == tianaoType) {
                            try {
                                Thread.sleep(2500);
                                kafkaTemplate.send(TopicConstants.TIANAO_TOPIC, data);
                                log.info(DateUtil.now() + "模拟天奥船舶:天奥模拟船舶2,FusionBatchNum为202302192完成");
                            } catch (InterruptedException e) {
                                e.printStackTrace();
                                Thread.currentThread().interrupt();
                                ;
                            }
                        }
                        if (1 == tianaoType) {
                            kafkaTemplate.send(TopicConstants.TIANAO_TOPIC, data);
                            log.info(DateUtil.now() + "模拟天奥船舶:天奥模拟船舶2,FusionBatchNum为202302192完成");
                        }

                    }
                }
            });
            thread.start();
            thread1.start();
            tianaoTherads.add(thread);
            tianaoTherads.add(thread1);
        }
        if (1 == tianaoStatus) {
            for (Thread item : tianaoTherads) {
                item.interrupt();
            }
        }
    }


    @Override
    public void beidouNewTrack(Integer status, Integer type) {
        //开始位置 109.11032753891612,19.687745190689267
        //结束位置 109.16730608884323,19.68914959156775
        //模拟同船的第一个设备
        beidouNewStatus = status;
        beidouType = type;
        if (0 == beidouNewStatus) {
            Thread thread = new Thread(() -> {
                while (true) {
                    boolean interrupted = Thread.currentThread().isInterrupted();
                    if (interrupted) {
                        break;
                    }
                    List<Location> list = LocationUtils.generateLogLatBeidou("2023-02-19 14:00:00", "2023-02-19 14:30:00", 109.11032753891612, 19.687745190689267, 109.16730608884323, 19.68914959156775);
                    for (Location location : list) {
                        BeidouShipTrackDTO beidouShipTrackDTO = new BeidouShipTrackDTO();
                        beidouShipTrackDTO.setId("202302193");
                        beidouShipTrackDTO.setCurren_time(DateUtil.now());
                        beidouShipTrackDTO.setTrackId(202302193);
                        beidouShipTrackDTO.setDeviceId(202302193);
                        beidouShipTrackDTO.setSendTime(DateUtil.now());
                        beidouShipTrackDTO.setLocationTime(DateUtil.now());
                        beidouShipTrackDTO.setShipName("202302193测试船舶");
                        beidouShipTrackDTO.setReceiveTime(DateUtil.now());
                        beidouShipTrackDTO.setLongitude(location.getLog());
                        beidouShipTrackDTO.setLatitude(location.getLat());
                        String data = JSONUtil.toJsonStr(beidouShipTrackDTO);
                        if (0 == beidouType) {
                            try {
                                Thread.sleep(1000);
                                kafkaTemplate.send(TopicConstants.BEIDOU_TOPIC, data);
                                log.info(DateUtil.now() + "模拟北斗船舶:202302193测试船舶,终端号为202302193完成");
                            } catch (InterruptedException e) {
                                Thread.currentThread().interrupt();
                                e.printStackTrace();
                            }
                        }
                        if (1 == beidouType) {
                            kafkaTemplate.send(TopicConstants.BEIDOU_TOPIC, data);
                            log.info(DateUtil.now() + "模拟北斗船舶:202302193测试船舶,终端号为202302193完成");
                        }

                    }
                }
            });
            thread.start();
            beidouNewThreads.add(thread);
        }
        if (1 == beidouNewStatus) {
            for (Thread item : beidouNewThreads) {
                item.interrupt();
            }
        }
    }

}
